// Dyalog APL Help in JS

var apl_help = {};

apl_help["←"] = `Left Arrow::
Assignment

Naming:
    V ← 5 6 7
    (i(j k)) ← 4(5 6)
    sum ← +⌿
    product ← {×/⍵}
    inverse ← ⍣¯1

Modification:
    V +← 1
    V[2] ← 0
    (⊃V) ← 2
`;

apl_help["+"] = `Plus::
Monadic function:  Conjugate

      + 1.2 0j4 ¯5j¯6
1.2 0J¯4 ¯5J6

Dyadic function:   Plus

      1 2 3 4 + 10
11 12 13 14

      1 2 3 + 2 ¯4 1
3 ¯2 4

      +/ 1 2 3
6
`;

apl_help["-"] = `Minus::
Monadic function:  Negate

      - 3.2 ¯7 0
¯3.2 7 0

Dyadic function:   Minus

      3 7 9 - 5
¯2 2 4

      5 1 4 - 2 3 4
3 ¯2 0
`;

apl_help["×"] = `Times::
Monadic function:  Direction

      × 3.1 ¯2 0 3j4
1 ¯1 0 0.6J0.8

Dyadic function:   Times

      2 ¯3 4.5 × ¯3 ¯4 2
¯6 12 9

      3 1 4 × 10
30 10 40

      ×/ 2 3 4
24
`;

apl_help["÷"] = `Divide::
Monadic function:  Reciprocal

      ÷ 1 2 3
1 0.5 0.333333

Dyadic function:   Divide

      1 2 3 ÷ 4 5 7
0.25 0.4 0.428571

      10 ÷ ¯2 0.5
¯5 20
`;

apl_help["*"] = `Star::
Monadic function:  Exponential

      * 0 1 2
1 2.71828 7.38906

Dyadic function:   Power

      49 5 ¯4 * 0.5 2 0.5
7 25 0J2
`;

apl_help["⍟"] = `Log::
Monadic function:  Natural Logarithm

      ⍟ 1 2 3 2.7182818285
0 0.693147 1.09861 1

Dyadic function:   Logarithm

      2 10 ⍟ 32 1000
5 3
`;

apl_help["⌹"] = `Domino::
Monadic function:  Matrix Inverse

      mat
1 2
3 4
      ⌹ mat
¯2    1
 1.5 ¯0.5

Dyadic function:   Matrix Divide

      5 6 ⌹ mat
¯4 4.5
`;

apl_help["○"] = `Circle::
Monadic function:  Pi Times

      ○ 0 1 2
0 3.14159 6.28319

Dyadic function:   Circular Functions (Trig)
          Note: Angles are in radians 
                radians ← ○ degrees ÷ 180

      1 ○ 0 1.5707963 3.1415927
0 1 ¯4.64102E¯8

 ⍺   ⍺ ○ ⍵         ⍺   ⍺ ○ ⍵    
                   0   (1-⍵*2)*0.5
¯1   Arcsin ⍵      1   Sine ⍵
¯2   Arccos ⍵      2   Cosine ⍵
¯3   Arctan ⍵      3   Tangent ⍵
¯4   (¯1+⍵*2)*0.5  4   (1+⍵*2)*0.5
¯5   Arcsinh ⍵     5   Sinh ⍵
¯6   Arccosh ⍵     6   Cosh ⍵
¯7   Arctanh ⍵     7   Tanh ⍵
¯8   -8○⍵          8   (-1+⍵*2)*0.5
¯9   ⍵             9   real part of ⍵
¯10  +⍵           10   |⍵
¯11  ⍵×0J1        11   imaginary part of ⍵
¯12  *⍵×0J1       12   phase of ⍵
`;

apl_help["!"] = `Exclamation Mark::
Monadic function:  Factorial

      ! 3 9 ¯0.11
6 362880 1.07683

Dyadic function:   Binomial

      2 1 3 ! 3 10 ¯0.11
3 10 ¯0.0429385
`;

apl_help["?"] = `Question Mark::
Monadic function:  Roll

      ? 6 6 6 6 6
4 3 6 3 5

      ? 0 0
0.260561 0.929928

Dyadic function:   Deal

      13 ? 52
36 31 44 11 27 42 13 8 2 33 19 34 6
`;

apl_help["|"] = `Stile::
Monadic function:  Magnitude (Absolute value)

      | 2.3 ¯4 0 3j4
2.3 4 0 5

Dyadic function:   Residue (Remainder/Modulus)

      2 10 ¯2.5 | 7 ¯13 8
1 7 ¯2
`;

apl_help["⌈"] = `Upstile::
Monadic function:  Ceiling (Round Up)

      ⌈ 3.4 ¯3.4 3 0
4 ¯3 3 0

Dyadic function:   Maximum

      1.1 ¯2 ⌈ 8.1 ¯3.4
8.1 ¯2

      ⌈/ 3 1 4 1
4
`;

apl_help["⌊"] = `Downstile::
Monadic function:  Floor (Round Down)

      ⌊ 3.4 ¯3.4 3 0
3 ¯4 3 0

Dyadic function:   Minimum

      1.1 ¯2 ⌊ 8.1 ¯3.4
1.1 ¯3.4

      ⌊/ 3 1 4 1
1
`;

apl_help["⊥"] = `Up Tack::
Dyadic function:   Decode

      2 ⊥ 1 1 0 1   ⍝ binary decode
13

⍝ mixed radix: conversion of hours,
⍝ minutes and seconds to seconds:

      24 60 60 ⊥ 2 46 40
10000
`;

apl_help["⊤"] = `Down Tack::
Dyadic function:   Encode

      2 2 2 2 ⊤ 5 7 12   ⍝ binary encode
0 0 1
1 1 1
0 1 0
1 1 0

⍝ mixed radix: encode of 10000 seconds
⍝ to hours, minutes and seconds:

      24 60 60 ⊤ 10000
2 46 40
`;

apl_help["⊣"] = `Left Tack::
Monadic function:   Same

      ⊣  1 2 3
1 2 3

Dyadic function: Left

      'L' ⊣ 'R'
L
      ⊣/ 1 2 3
1
`;

apl_help["⊢"] = `Right Tack::
Monadic function:  Same

      ⊢  1 2 3
1 2 3

Dyadic function:   Right

      'L' ⊢ 'R'
R
      ⊢/ 1 2 3
3
`;

apl_help["="] = `Equal::
Dyadic function:   Equal To

      1 2 3 = 4 2 ¯1
0 1 0

      0 1 0 1 = 0 0 1 1
1 0 0 1

      'Banana' = 'a'
0 1 0 1 0 1

      7 = '7'
0
`;

apl_help["≠"] = `Not Equal::
Monadic function:  Unique Mask

      ≠ 'Banana'
1 1 1 0 0 0

      ≠ 'Mississippi'
1 1 1 0 0 0 0 0 1 0 0


Dyadic function:   Not Equal To

      1 2 3 ≠ 4 2 ¯1
1 0 1

      0 1 0 1 ≠ 0 0 1 1
0 1 1 0

      'Banana' ≠ 'a'
1 0 1 0 1 0

      7 ≠ '7'
1
`;

apl_help["≤"] = `Less Than Or Equal To::
Dyadic function:   Less Than or Equal To

      1 2 3 ≤ 4 2 ¯1
1 1 0
      1 2 3 ≤ 2
1 1 0
`;

apl_help["<"] = `Less Than::
Dyadic function:   Less Than

      1 2 3 < 4 2 ¯1
1 0 0
      1 2 3 < 2
1 0 0
`;

apl_help[">"] = `Greater Than::
Dyadic function:   Greater Than

      1 2 3 > 4 2 ¯1
0 0 1
      1 2 3 > 2
0 0 1
`;

apl_help["≥"] = `Greater Than Or Equal To::
Dyadic function:   Greater Than or Equal To

      1 2 3 ≥ 4 2 ¯1
0 1 1
      1 2 3 ≥ 2
0 1 1
`;

apl_help["≡"] = `Equal Underbar::
Monadic function:  Depth

      ≡ 7
0
      ≡ 'abc'
1
      ≡ (1 2)(3 4)
2
      ≡ (1 2)(3 4)5
¯2

Dyadic function:   Match

      'b' 'e' 'x' ≡ 'bex'
1
      1 ≡ 1 1
0
`;

apl_help["≢"] = `Equal Underbar Slash::
Monadic function:  Tally 

      ≢ 'a'
1
      ≢ 7 4 2
3
      ≢ 5 4 3⍴0 
5
      ≢ (1 2)(3 4)
2
     mat
1 2 3
4 5 6
      ≢ mat   ⍝ note how \"tally\"
2
      ⍴ mat   ⍝ differs from \"shape\"
2 3

Dyadic function:   Not Match 

      'bex' ≢ 'b','e','x' 
0
      1 ≢ 1 1
1
`;

apl_help["∨"] = `Logical OR::
Dyadic function:   Greatest Common Divisor (OR)

      0 1 0 1 ∨ 0 0 1 1
0 1 1 1

      15 1 2 7 ∨ 35 1 4 0
5 1 2 7
`;

apl_help["∧"] = `Logical AND::
Dyadic function:  Lowest Common Multiple (AND)

      0 1 0 1 ∧ 0 0 1 1
0 0 0 1

      15 1 2 7 ∧ 35 1 4 0
105 1 4 0
`;

apl_help["⍲"] = `Logical NAND::
Dyadic function:   NAND

      0 1 0 1 ⍲ 0 0 1 1
1 1 1 0
`;

apl_help["⍱"] = `Logical NOR::
Dyadic function:   NOR

      0 1 0 1 ⍱ 0 0 1 1
1 0 0 0
`;

apl_help["↑"] = `Up Arrow::
Monadic function:  Mix

      ↑ 'Hip' 'Hop'
Hip
Hop
      ↑ (6 4) 5 3
6 4
5 0
3 0
      ↑[0.5] 'Hip' 'Hop'
HH
io
pp

Dyadic function:   Take

      4 ↑ 'Pineapple'
Pine
      ¯5 ↑ 'Pineapple'
apple

      mat
1  2  3  4
5  6  7  8
9 10 11 12

      2 ¯3 ↑ mat
2 3 4
6 7 8

      ¯2 ↑ mat
5  6  7  8
9 10 11 12

      ¯2 3 ↑ 7
0 0 0
7 0 0
`;

apl_help["↓"] = `Down Arrow::
Monadic function:  Split

      mat
1  2  3  4
5  6  7  8
9 10 11 12

      ↓ mat
┌───────┬───────┬──────────┐
│1 2 3 4│5 6 7 8│9 10 11 12│
└───────┴───────┴──────────┘

      ↓[1] mat
┌─────┬──────┬──────┬──────┐
│1 5 9│2 6 10│3 7 11│4 8 12│
└─────┴──────┴──────┴──────┘

Dyadic function:   Drop

      4 ↓ 'Pineapple'
apple
      ¯5 ↓ 'Pineapple'
Pine
      1 ¯2 ↓ mat
5  6
9 10
      1 ↓ mat
5  6  7  8
9 10 11 12
`;

apl_help["⊂"] = `Left Shoe::
Monadic function:  Enclose

      1(2 3)
┌─┬───┐
│1│2 3│
└─┴───┘
      ⊂ 1(2 3)
┌───────┐
│┌─┬───┐│
││1│2 3││
│└─┴───┘│
└───────┘
      ⊂⊂ 1(2 3)
┌─────────┐
│┌───────┐│
││┌─┬───┐││
│││1│2 3│││
││└─┴───┘││
│└───────┘│
└─────────┘

Dyadic function:   Partitioned Enclose

       0 1 0 1 ⊂ 1 2 3 4
┌───┬─┐
│2 3│4│
└───┴─┘
`;

apl_help["⊃"] = `Right Shoe::
Monadic function:  First

      ⊃ 'Word'
W
      ⊃ (1 2)(3 4 5)
1 2

Dyadic function:   Pick

      3 ⊃ 'Word'
r
      2 ⊃ (1 2)(3 4 5)
3 4 5

      2 1 ⊃ (1 2)(3 4 5)
3
`;

apl_help["⊆"] = `Left Shoe Underbar::
Monadic function:  Nest

      ⊆ 'this'
┌────┐
│this│
└────┘
      ⊆ 'this' 'that'
┌────┬────┐
│this│that│
└────┴────┘

Dyadic function:   Partition

      1 0 0 1 1 ⊆ 1 2 3 4 5
┌─┬───┐
│1│4 5│
└─┴───┘
       1 1 2 2 2⊆⍳5
┌───┬─────┐
│1 2│3 4 5│
└───┴─────┘
    ' ' (≠⊆⊢) ' many a  time'
┌────┬─┬────┐
│many│a│time│
└────┴─┴────┘
`;

apl_help["⌷"] = `Squad::
Monadic function:  Materialise

      ⌷ ⍵
If ⍵ is an array, returns ⍵.
If ⍵ is ref to an instance of a Class with a 
Numbered Default property, all items of that property
are returned.
If ⍵ is a collection, returns all elements
in the collection as an array.

Dyadic function:   Index

      mat
1  2  3  4
5  6  7  8
9 10 11 12

      2 3 ⌷ mat
7
      2 ⌷ mat
5 6 7 8

      2 ⌷[2] mat
2 6 10
`;

apl_help["⍋"] = `Grade Up::
Monadic function:  Grade Up

Indices which would select items in ascending order.

      ⍋ 33 11 44 66 22
2 5 1 3 4

      names←'Joe' 'Sue' 'Sam'
      ages←34 22 25

      names[⍋ages]
┌───┬───┬───┐
│Sue│Sam│Joe│
└───┴───┴───┘

      ⍋ 'ABC' ⎕NULL ⍬ ¯3j4 'A'
3 2 4 5 1

Dyadic function:   Dyadic Grade Up

Provide collating sequence for character data.

      ⍋ 'Banana'
1 2 4 6 3 5

      'an' ⍋ 'Banana'
2 4 6 3 5 1
`;

apl_help["⍒"] = `Grade Down::
Monadic function:  Grade Down

Indices which would select items in descending order.

      ⍒ 33 11 44 66 22
4 3 1 5 2

      names←'Joe' 'Sue' 'Sam'
      ages←34 22 25

      names[⍒ages]
┌───┬───┬───┐
│Joe│Sam│Sue│
└───┴───┴───┘ 

      ⍒ 'ABC' ⎕NULL ⍬ ¯3j4 'A'
1 5 4 2 3

Dyadic function:   Dyadic Grade Down

Provide collating sequence for character data.

      ⍒ 'Banana'
3 5 2 4 6 1

      'an' ⍒ 'Banana'
1 3 5 2 4 6
`;

apl_help["⍳"] = `Iota::
Monadic function:  Index Generator

      ⍳ 10
1 2 3 4 5 6 7 8 9 10

      ⍳ 2 3
┌───┬───┬───┐
│1 1│1 2│1 3│
├───┼───┼───┤
│2 1│2 2│2 3│
└───┴───┴───┘

Dyadic function:   Index Of

      'ABCDABCDEF' ⍳ 'ACF'
1 3 10

      mat
1 2
3 4
5 6
      mat ⍳ 5 6
3
`;

apl_help["⍸"] = `Iota Underbar::
Monadic function:  Where

      ⍸ 1 0 0 1 1
1 4 5
      bmat
0 1 0
1 0 1
      ⍸ bmat
┌───┬───┬───┐
│1 2│2 1│2 3│
└───┴───┴───┘

Dyadic function:   Interval Index

      'AEIOU' ⍸ 'DYALOG'
1 5 1 3 4 2

      2 4 6 ⍸ 1 2 3 4 5 6 7
0 1 1 2 2 3 3

      mat
1 2
3 4
5 6
      mat ⍸ 3 3
1
      mat ⍸ 3 5
2
`;

apl_help["∊"] = `Epsilon::
Monadic function:  Enlist

      mat
1 2 3
4 5 6
      ∊ 0 mat (7 8) 9
0 1 2 3 4 5 6 7 8 9

      ∊ 2 3⍴1 'abc'
1 abc 1 abc 1 abc

Dyadic function:   Membership

      'abc' 4 ∊ 4 'ab' 'abcd'
0 1
      mat ∊ 6 2 7 4
0 1 0
1 0 1
`;

apl_help["⍷"] = `Epsilon Underbar::
Dyadic function:   Find

      'ana' ⍷ 'Banana'
0 1 0 1 0 0

      X Y
┌───┬───────┐
│0 1│0 1 0 0│
│1 0│1 0 0 1│
│   │0 0 1 0│
│   │0 1 0 0│
└───┴───────┘

      X ⍷ Y
1 0 0 0
0 0 1 0
0 1 0 0
0 0 0 0
`;

apl_help["∪"] = `Down Shoe::
Monadic function:  Unique

      ∪ 'ab' 'ba' 'ab' 1 1 2
┌──┬──┬─┬─┐
│ab│ba│1│2│
└──┴──┴─┴─┘

      mat
flywheel
shyster 
flywheel
     ∪mat
flywheel
shyster 

Dyadic function:   Union

      'ab' 'cde' 'fg' ∪ 'a' 'ab'
┌──┬───┬──┬─┐
│ab│cde│fg│a│
└──┴───┴──┴─┘
`;

apl_help["∩"] = `Up Shoe::
Dyadic function:   Intersection

      22 'ab' 'fg' ∩ 'a' 'ab' 22
┌──┬──┐
│22│ab│
└──┴──┘
`;

apl_help["~"] = `Tilde::
Monadic function:  NOT

      ~ 0 1 0 1
1 0 1 0

Dyadic function:   Without

      3 1 4 1 5 ~ 5 1
3 4

      'aa' 'bb' 'cc' 'bb'  ~ 'bb' 'xx'
┌──┬──┐
│aa│cc│
└──┴──┘
`;

apl_help["/"] = `Slash::
Dyadic function:   Replicate

      3 1 ¯2 2 / 6 7 8 9
6 6 6 7 0 0 9 9

      1 0 1 0 1 / 'Heart'
Hat

Monadic operator: Reduce (Fold, N-Wise Reduce)

      +/ 1 2 3 4 5
15
      2 +/ 1 2 3 4 5   ⍝ pair-wise sum
3 5 7 9

      cube    ⍝ 3D array
 1  2  3  4
 5  6  7  8
 9 10 11 12

13 14 15 16
17 18 19 20
21 22 23 24

      +/ cube
10 26 42
58 74 90

      +/[1] cube    ⍝ sum of planes
14 16 18 20
22 24 26 28
30 32 34 36

      +/[2] cube    ⍝ column sums
15 18 21 24
51 54 57 60
`;

apl_help["\\"] = `Backslash::
Dyadic function:   Expand

      3 ¯2 4 \\ 7 8
7 7 7 0 0 8 8 8 8

      1 0 1 0 1 \\ 'Hat'
H a t

Monadic operator: Scan

      +\\ 1 2 3 4 5
1 3 6 10 15

      mat
1  2  3  4
5  6  7  8
9 10 11 12

      +\\ mat
1  3  6 10
5 11 18 26
9 19 30 42

      +\\[1] mat
 1  2  3  4
 6  8 10 12
15 18 21 24
`;

apl_help["⌿"] = `Slash Bar::
Dyadic function:  Replicate First (Compress First)

      mat
1  2  3  4
5  6  7  8
9 10 11 12

      1 0 2 ⌿ mat
1  2  3  4
9 10 11 12
9 10 11 12

Monadic operator: Reduce First

      +⌿ mat
15 18 21 24

      2 +⌿ mat     ⍝ pair-wise
 6  8 10 12
14 16 18 20
`;

apl_help["⍀"] = `Backslash Bar::
Dyadic function:   Expand First

      mat
1  2  3  4
5  6  7  8
9 10 11 12

      1 0 2 1 ⍀ mat
1  2  3  4
0  0  0  0
5  6  7  8
5  6  7  8
9 10 11 12

Monadic operator: Scan First

      +⍀ mat
 1  2  3  4
 6  8 10 12
15 18 21 24 
`;

apl_help[","] = `Comma::
Monadic function:  Ravel

      cube    ⍝ 3D array
1 2
3 4

5 6
7 8
      , cube
1 2 3 4 5 6 7 8

      ,[2 3] cube    ⍝ Ravel with axes
1 2 3 4
5 6 7 8

Dyadic function:   Catenate/Laminate (Join)

      1 2 3 , 4 5 6
1 2 3 4 5 6

      cube , 99
1 2 99
3 4 99

5 6 99
7 8 99

      1 2 3 ,[0.5] 4 5 6   ⍝ Laminate
1 2 3
4 5 6 
`;

apl_help["⍪"] = `Comma Bar::
Monadic function:  Table

      ⍪ 2 3 4
2
3
4
      cube    ⍝ 3D array
1 2
3 4

5 6
7 8
      ⍪ cube
1 2 3 4
5 6 7 8

Dyadic function:   Catenate First/Laminate

      mat
1 2 3
4 5 6

      mat ⍪ 0
1 2 3
4 5 6
0 0 0

      mat ⍪ 7 8 9
1 2 3
4 5 6
7 8 9
`;

apl_help["⍴"] = `Rho::
Monadic function:  Shape

      mat
1  2  3  4
5  6  7  8
9 10 11 12

      ⍴ mat
3 4
      ⍴⍴ mat
2
      ⍴ 'your boat'
9
      ⍴ 7

      ⍴⍴ 7
0

Dyadic function:   Reshape

      2 3 4 ⍴ 1 2 3 4 5 6 7
1 2 3 4
5 6 7 1
2 3 4 5

6 7 1 2
3 4 5 6
7 1 2 3
`;

apl_help["⌽"] = `Circle Stile::
Monadic function:  Reverse

      ⌽ 'trams'
smart

      mat
1  2  3  4
5  6  7  8
9 10 11 12

      ⌽ mat
 4  3  2 1
 8  7  6 5
12 11 10 9

      ⌽[1] mat
9 10 11 12
5  6  7  8
1  2  3  4

Dyadic function:   Rotate

      3 ⌽ 'HatStand'
StandHat

      ¯2 ⌽ 1 2 3 4 5 6
5 6 1 2 3 4

      ¯1 ⌽ mat
 4 1  2  3
 8 5  6  7
12 9 10 11

      1 ¯1 2 ⌽ mat
 2  3 4  1
 8  5 6  7
11 12 9 10

      0 1 2 ¯1 ⌽[1] mat
1  6 11 12
5 10  3  4
9  2  7  8
`;

apl_help["⊖"] = `Circle Bar::
Monadic function:  Reverse First

      mat
1  2  3  4
5  6  7  8
9 10 11 12

      ⊖ mat
9 10 11 12
5  6  7  8
1  2  3  4

Dyadic function:   Rotate First

      0 1 2 ¯1 ⊖ mat
1  6 11 12
5 10  3  4
9  2  7  8
`;

apl_help["⍉"] = `Transpose::
Monadic function:  Transpose

      mat
1 2 3
4 5 6

      ⍉ mat
1 4
2 5
3 6


Dyadic function:   Dyadic Transpose

      2 1 ⍉ mat
1 4
2 5
3 6
			
      1 1 ⍉ mat   ⍝ leading diagonal
1 5

`;

apl_help["¨"] = `Diaeresis::
Monadic operator: Each (Map)

      ⊃¨ 1 2 3 'ABC' (9 8 7)
1 2 3 A 9

      +/¨ (1 2 3 4)(5 6 7)
10 18

      3 ↑¨ 1 2 (3 4) 'V'
┌─────┬─────┬─────┬───┐
│1 0 0│2 0 0│3 4 0│V  │
└─────┴─────┴─────┴───┘

      1 2 3 ,¨ 99
┌────┬────┬────┐
│1 99│2 99│3 99│
└────┴────┴────┘
`;

apl_help["⍨"] = `Tilde Diaeresis::
Monadic operator (f⍨): Commute (Switch)

      2 ⍴ 3     ⍝ ⍺ ⍴ ⍵
3 3
      2 ⍴⍨ 3    ⍝ ⍵ ⍴ ⍺
2 2 2
      ⍴⍨ 3      ⍝ ⍵ ⍴ ⍵
3 3 3

Monadic operator (a⍨): Constant

      'mu'⍨ 'any' ⎕NULL   ⍝ Always returns its operand
mu
      1E100 ('mu'⍨) 1j1
mu
      ¯1⍨¨ ⍳2 3
¯1 ¯1 ¯1
¯1 ¯1 ¯1
`;

apl_help["⍣"] = `Star Diaeresis::
Dyadic operator: Power

      cube    ⍝ 3D array
AB
CD

EF
GH
      (↓⍣1) cube   ⍝ split once
┌──┬──┐
│AB│CD│
├──┼──┤
│EF│GH│
└──┴──┘
      (↓⍣2) cube   ⍝ split twice
┌───────┬───────┐
│┌──┬──┐│┌──┬──┐│
││AB│CD│││EF│GH││
│└──┴──┘│└──┴──┘│
└───────┴───────┘

      f ← (32∘+)∘(×∘1.8)   ⍝ Fahrenheit from Celsius

      f ¯273 ¯40 0 100     ⍝ Fahrenheit
¯459.4 ¯40 32 212

      c ← f⍣¯1             ⍝ Inverse: Celsius from Fahrenheit

      c ¯459.4 ¯40 32 212  ⍝ Celsius
¯273 ¯40 0 100

      1 +∘÷⍣= 1            ⍝ fixpoint: golden mean
1.61803 
`;

apl_help["."] = `Dot::
Dyadic operator: Product

Inner Product f.g      

      1 2 3 +.× 4 5 6
32
      3 ∧.= 3 3 3 3
1
      mat
1 2
3 4
      mat +.× mat   ⍝ matrix product
 7 10
15 22

Outer Product ∘.g

      1 2 3 ∘.× 4 5 6 7
 4  5  6  7
 8 10 12 14
12 15 18 21
`;

apl_help["∘"] = `Jot::
Dyadic operator: Beside and Bind

NB: ∘ is also used in outer product ∘.f - see Dot (.)

Beside

      ⌽∘⍳¨ 3 4 5
┌─────┬───────┬─────────┐
│3 2 1│4 3 2 1│5 4 3 2 1│
└─────┴───────┴─────────┘

      ¯1 ⌽∘⍳¨ 3 4 5
┌─────┬───────┬─────────┐
│3 1 2│4 1 2 3│5 1 2 3 4│
└─────┴───────┴─────────┘

      +∘÷/ 40⍴1    ⍝ continued fraction
1.61803
`;

apl_help["⍤"] = `Jot Diaeresis::
Dyadic operator (f⍤g): Atop

      -⍤÷ 4      ⍝ (  f⍤g y) ≡  f   g y
¯0.25
      12 -⍤÷ 4   ⍝ (x f⍤g y) ≡ (f x g y)
¯3
      3 1 4 1 5 ~⍤∊ 1 2 3
0 0 1 0 1

Dyadic operator (f⍤a):   Rank 

      cube    ⍝ 3D array
 1  2  3
 4  5  6

 7  8  9
10 11 12

      (,⍤2) cube
1 2 3  4  5  6
7 8 9 10 11 12

      cmat    ⍝ character matrix
abc
zxy 
      (⍋⍤1) cmat    ⍝ grade-up by row  
1 2 3 
2 3 1 
      nmat     ⍝ numeric matrix
1  2  3  4
5  6  7  8
9 10 11 12

      10 20 30 (+⍤0 1) nmat  ⍝ scalars plus vectors
11 12 13 14 
25 26 27 28 
39 40 41 42
`;

apl_help["⍥"] = `Circle Dieresis::
Dyadic operator: Over

      -⍥⌊ 3.6                 ⍝ Same as ∘ or ⍤ monadically
¯3
      5.1 -⍥⌊ 3.6             ⍝ Applies ⌊ to both arguments
2
      'Dyalog' ≡⍥⎕C 'DYALOG'  ⍝ Case-insensitive match
1
      'Dyalog' ≡⍥⎕C 'IBM'
0
`;

apl_help["@"] = `At::
Dyadic operator: At

      (0@2 4) 1 2 3 4 5
1 0 3 0 5

      10 (×@2 4) 1 2 3 4 5
1 20 3 40 5

      (÷@2 4) 1 2 3 4 5
1 0.5 3 0.25 5

      '*'@(2∘|) 1 2 3 4 5   ⍝ Boolean selection 1 0 1 0 1
* 2 * 4 *

      ⌽@(2∘|) 1 2 3 4 5     ⍝ Reversal of sub-array 1 3 5
5 2 3 4 1
`;

apl_help["⍞"] = `Quote Quad::
Niladic:     Character Input/Output

      chars ← ⍞     ⍝ input session line
hello
      chars
hello
      ⍞ ← 'Name:'   ⍝ places text in session
Name: 
      ask ← {⍞←⍵ ⋄ (≢⍵)↓⍞}   ⍝ prompt for input:

      name ← ask¨ 'First:  ' 'Second: '
First:  John
Second: Brown

      name
┌────┬─────┐
│John│Brown│
└────┴─────┘
`;

apl_help["⎕"] = `Quad::
Niladic:     Evaluated Input/Output

      2+⎕+4
⎕:
      8-5
9

      2+⎕←3+4
7
9
`;

apl_help["⍠"] = `Quad Colon::
Dyadic operator: Variant

      ('a' ⎕R 'x') 'ABC'           ⍝ 'a' replaced with 'x'
ABC

      ('a' ⎕R 'x' ⍠ 'IC' 1) 'ABC'  ⍝ .. Ignoring Case
xBC

      IgnCase ← ⍠ 'IC' 1

      'a' ⎕R 'x' IgnCase 'ABC'
xBC 
`;

apl_help["⌸"] = `Quad Equal::
Monadic operator:  Key 

      'Banana' {⍺ ⍵}⌸ 3 1 4 1 5 9
┌─┬─────┐
│B│3    │
├─┼─────┤
│a│1 1 9│
├─┼─────┤
│n│4 5  │
└─┴─────┘
      'Banana' {⍺,+/⍵}⌸ 3 1 4 1 5 9
B  3
a 11
n  9     
      'Banana' {⍺ ⍵}⌸ 1 2 3 4 5 6
┌─┬─────┐
│B│1    │
├─┼─────┤
│a│2 4 6│
├─┼─────┤
│n│3 5  │
└─┴─────┘
      {⍺ ⍵}⌸ 'Banana'  ⍝ (same as above)
┌─┬─────┐
│B│1    │
├─┼─────┤
│a│2 4 6│
├─┼─────┤
│n│3 5  │
└─┴─────┘
`;

apl_help["⌺"] = `Quad Diamond::
Dyadic operator:  Stencil

      mat
 1  2  3  4
 5  6  7  8
 9 10 11 12
13 14 15 16

      ({⊂⍵}⌺3 3) mat
┌───────┬────────┬────────┬───────┐
│0 0 0  │0 0 0   │0 0 0   │0 0 0  │
│0 1 2  │1 2 3   │2 3 4   │3 4 0  │
│0 5 6  │5 6 7   │6 7 8   │7 8 0  │
├───────┼────────┼────────┼───────┤
│0 1  2 │1  2  3 │ 2  3  4│ 3  4 0│
│0 5  6 │5  6  7 │ 6  7  8│ 7  8 0│
│0 9 10 │9 10 11 │10 11 12│11 12 0│
├───────┼────────┼────────┼───────┤
│0  5  6│ 5  6  7│ 6  7  8│ 7  8 0│
│0  9 10│ 9 10 11│10 11 12│11 12 0│
│0 13 14│13 14 15│14 15 16│15 16 0│
├───────┼────────┼────────┼───────┤
│0  9 10│ 9 10 11│10 11 12│11 12 0│
│0 13 14│13 14 15│14 15 16│15 16 0│
│0  0  0│ 0  0  0│ 0  0  0│ 0  0 0│
└───────┴────────┴────────┴───────┘

      ({+/,⍵}⌺3 3) mat
14 24 30 22
33 54 63 45
57 90 99 69
46 72 78 54
`;

apl_help["⌶"] = `I-Beam::
Monadic operator:  I-Beam

Provides a system-related service
determined by the left-operand value.
(see Dyalog APL Language Reference Guide)

`;

apl_help["⍎"] = `Hydrant::
Monadic function:  Execute

      ⍎ '1+1'
2
      V ← 1 2 3
      ⍎ 'V'
1 2 3 
`;

apl_help["⍕"] = `Thorn::
Monadic function:  Format

NB: In the following examples space characters
    are represented by small dots: ···

      4 5 6          ⍝ numeric vector
4 5 6
      ⍕ 4 5 6        ⍝ equivalent character vector
4·5·6

      mat            ⍝ numeric matrix
1 2 3
4 5 6

      ⍕ mat          ⍝ equivalent character matrix
1·2·3
4·5·6

Dyadic function:   Format By Specification

Field-width and number of decimal places:

      6 2 ⍕ 3.125 0.002
··3.13··0.00

      6 2 ⍕ mat
··1.00··2.00··3.00
··4.00··5.00··6.00

      6 2 ⍕ 1234   ⍝ (field not wide enough)
******
`;

apl_help["⋄"] = `Diamond::
Syntax:    Statement Separator

      Statements are evaluated sequentially
      from left to right.

      A←4 ⋄ A←A×3 ⋄ A÷2
6
`;

apl_help["⍝"] = `Lamp::
Syntax: Comment

Text to the right of ⍝ is ignored.

      2+3  ⍝ this is a comment
5
`;

apl_help["→"] = `Right Arrow::
Syntax:  Branch (Clear suspension)

      → Label  ⍝ branch to Label:
      → ⎕LC    ⍝ resume suspended execution
      → 0      ⍝ exit current function and resume calling line
      →        ⍝ clear one stack suspension

Branching is superseded by the more modern
control structures such as :If ... :EndIf
`;

apl_help["⍵"] = `Omega::
Omega Syntax:           Right argument of a dfn

      2 {⍵+1} 5
6

Double-Omega Syntax:    Right operand of a dop

      3 +{⍺ ⍵⍵ ⍵}× 4
12

`;

apl_help["⍺"] = `Alpha::
Alpha Syntax:           Left argument of a dfn

      2 {⍺+1} 5
3
Double-Alpha Syntax:    Left Operand of a dop

      3 +{⍺ ⍺⍺ ⍵} 4
7
`;

apl_help["∇"] = `Del::
Del Syntax:         dfn self-reference (recursion)

      fact←{             ⍝ Factorial ⍵.
          ⍵≤1: 1         ⍝ small ⍵: finished
          ⍵×∇ ⍵-1        ⍝ otherwise: recurse
      }

Double-Del Syntax:  dop self-reference

    pow←{                ⍝ power operator: apply ⍵⍵ times
        ⍵⍵=0:⍵           ⍝ ⍵⍵ is 0: finished
        ⍺⍺ ∇∇(⍵⍵-1)⍺⍺ ⍵  ⍝ otherwise: recurse
    }
`;

apl_help["&"] = `Ampersand::
Monadic operator:  Spawn

      delay←{'Delayed: ',⎕DL ⍵}    ⍝ delay function

      delay 10    ⍝ delay for 10 seconds
Delayed:  10.2228

      ⎕←delay&10  ⍝ delay for 10 seconds in new thread 1
1

      2+3 4       ⍝ execute something in current thread
5 6
                  ⍝ thread 1 completes:
Delayed:  10.03183
`;

apl_help["¯"] = `High Minus::
Qualifier for negative number

      1 + ¯1 0 1 ¯3
0 1 2 ¯2

      3e¯2
0.03
`;

apl_help["⍬"] = `Zilde::
Niladic:  Empty Numeric Vector

      ⍬≡⍳0
1
      ⍬≡0⍴0
1
      ⍬≡0 0⍴0
0
      ⍬≡''
0


`;

// end
