<?php

// io.php

// see sample JS below

/* test
echo "<pre>\n";
echo "_GET = \n";
print_r( $_GET );
echo "\n";

echo "_POST = \n";
print_r( $_POST );
echo "\n";

echo "_SERVER = \n";
print_r( $_SERVER );
echo "\n";
*/

die('io.php is off');

// GET or POST supported
$op = $_GET['op'];
if ( $op == null ) $op = $_POST['op'];

$fn = $_GET['fn'];
if ( $fn == null ) $fn = $_POST['fn'];

// $fn = 'samples/'.basename( $fn );
$fn = basename( $fn );
if ( preg_match("/php/i", $fn) ) die('error: php file write not allowed');     // basic security

if ( $op == 'PUT' ) {
    // direct read, see: https://www.php.net/manual/en/wrappers.php.php#wrappers.php.input
    // for client, use POST with header: http.setRequestHeader( "Content-type", "application/octet-stream" )
    // see: https://stackoverflow.com/questions/12348216/uploading-a-file-with-xmlhttprequest-missing-boundary-in-multipart-form-data
    $data = file_get_contents('php://input');
    // $data = 'none';
    if ( strlen( $data ) == 0 ) {
        echo "error: zero length!  file NOT saved\n";
    } else {
        // echo "strlen( data ) = ".strlen( $data );
        // echo "\ndata = \n";
        // print_r( $data );
        file_put_contents( $fn, $data );
        echo "saved at ".date("H:i:s")."\n";
        // echo "saving to cloud is currently OFF, \n";
    }
} else if ( $op == 'APPEND' ) {
    $data = file_get_contents('php://input');
    file_put_contents( $fn, $data, FILE_APPEND );
    echo "appended\n";
} else if ( $op == 'GET' ) {
    // nb. bypasses HTTP server and any transformations
    $data = 'error: file unreadable';
    if ( is_readable( $fn ) ) $data = file_get_contents( $fn );
    echo $data;
}

return;

/*
<script>

// client side I/O utilities for cloud storage
// similar to fs.writeFileSync() and fs.readFileSync() in Node.js

function storeIO( fn, s, append, cb )
{
    log('storeIO to '+fn)
    let op = append || 'PUT'; // ? 'APPEND' : 'PUT'
    fetch( 'io.php?op='+op+'&fn='+fn,
        {
            method: "POST",
            headers: {
                'Content-Type': 'application/octet-stream',
                // 'Authorization':'Basic base64pswd',
            },
            body: s
        })
        .then(response => response.text())
        .then((data) =>
            {
                console.log("storeIO rsp data = " + data);
                if (cb) cb();
            }
        );
}

function loadIO( fn, cb )
{
    // read
    fetch( 'io.php?op=GET&fn='+fn,
        {
            method: "POST",
            // headers: {
            //     'Authorization':'Basic base64pswd',
            // },
        })
        .then(response => response.text())
        .then((data) =>
            {
                // console.log("loadIO rsp 2 data = " + data);
            	cb( data );
            }
        );
}

// tests:
// storeIO( 'test.txt', 'testing123\n', 'APPEND' );
// storeIO( 'test.txt', 'testing456\n', 'APPEND' );
// loadIO( 'test.txt', ( d ) => log('d = '+d) );

</script>

*/

?>


